SystemOrganization addCategory: #'Pier-Debugging'!

!WAGlobalConfiguration class methodsFor: '*pier-debugging-override' stamp: 'kph 8/17/2007 08:04'!
setDeploymentMode
	DeploymentMode := true.
	
	Preferences allPreferenceObjects do: [ :each | 
		
		(each categoryList includes: PRDebugging category) ifTrue: [ each restoreDefaultValue  ]
		
	].! !

!PRContentsWidget methodsFor: '*pier-debugging-override' stamp: 'kph 8/19/2007 04:14'!
onAnswerCommand: aCommand
	aCommand isNil
		ifTrue: [ ^ self context: (self context structure: self context structure) ].
	[ aCommand execute ]
		on: Error
		do: [ :err | 
			 
			Preferences debugPierFormErrors ifTrue: [ err pass ].
			
			^ self component errors add: err.  ].
	self context: aCommand answer! !

!WAComponent methodsFor: '*pier-debugging-override' stamp: 'kph 8/17/2007 06:59'!
decoration
	decoration ifNil: [ self error: 'I bet you didnt put super initialize in that new component did you?' ].
	^ decoration contents! !

!MAMultipleOptionDescription methodsFor: '*pier-debugging-override' stamp: 'kph 10/4/2007 15:06'!
validateKind: anObject
 Preferences ignoreKindValidation ifTrue: [ self log warn: 'Kind Validation Ignored'. ^ self  ].
	super validateKind: anObject.
	(anObject allSatisfy: [ :each | self options includes: each ])
		ifFalse: [ MAKindError description: self signal: self kindErrorMessage ]! !

!PRPierMain methodsFor: '*pier-debugging-override' stamp: 'kph 8/22/2007 23:00'!
forbidden: aRequest

	| page command |
	
	Preferences haltOnForbidden  ifTrue: [ self halt ].

	"self return: (WAResponse forbidden: aRequest url)"

	self context: (PRContext kernel: self kernel).

	page :=	PRPathLookup
		start: self kernel root path: '/site/access+denied'
		onError: [ self notFound: aRequest ].
		

	PRCurrentContext use: self during: [
		command :=	 page defaultCommandClass  new
			setContext: self context;
			initialRequest: aRequest;
			yourself.
			
		self context
			setStructure: page;
			setCommand: command.
		self context isValid
			ifFalse: [ self halt. self return: (WAResponse forbidden: aRequest url) ] ].

	super start: aRequest! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 9/13/2007 23:13'!
conflictErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #conflictErrorMessage ifAbsent: [ 'Input is conflicting with concurrent modification' ]! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 8/19/2007 02:55'!
kindErrorMessage

 
   Preferences debugPierFormErrors ifTrue: [ self halt ].
	^ self propertyAt: #kindErrorMessage ifAbsent: [ 'Invalid input given' ]! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 9/13/2007 23:14'!
multipleErrorsMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #multipleErrorsMessage ifAbsent: [ 'Multiple errors' ]! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 9/13/2007 23:14'!
requiredErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #requiredErrorMessage ifAbsent: [ 'Input is required but no input given' ]! !
